image: docker:latest
services:
  - name: docker:dind
    alias: webapp-odoo

stages:
  - Build
  - Test acceptation
  - Release 
  - Deploy test
  - Test test
  - Stop test

variables:
  SERVER_USER: ubuntu
  SERVER_IP: 18.208.254.239 #Public IP address EC2 on AWS

.test_template: &test
  image: alpine
  only:
   - main
  script:
   - apk --no-cache add curl
   - curl -I "http://$DOMAIN"

docker-build:
  stage: Build
  script:
    #- apk add --no-cache bash # Ensure bash is installed if not available
    #- chmod +x env_vars.sh
    #- bash env_vars.sh
    #- echo "affichage des variables d'environnement" && env
    - docker build --tag ic-webapp:1.0 .
    - docker save ic-webapp > ic-webapp.tar
  artifacts:
    paths:
      - ic-webapp.tar

test-acceptation:
  stage: Test acceptation
  script:
    - docker rmi -f ic-webapp:1.0 >/dev/null 2>&1 && echo "Image précédente supprimé." || echo "Aucune image du même nom n'exite."
    - docker load < ic-webapp.tar
    - docker rm -f ic-webapp-test >/dev/null 2>&1 && echo "Conteneur précédent supprimé." || echo "Aucun conteneur du même nom n'exite."
    - docker run -d -p 8080:8080 --name ic-webapp-test ic-webapp:1.0
    - sleep 5
    - apk --no-cache add curl
    #- ip_address=$(docker inspect -f '{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' ic-webapp-test)
    - curl -I "http://webapp-odoo:8080"
    - echo "Adresse IP du conteneur  $ip_address"
    - docker stop ic-webapp-test && docker rm -vf ic-webapp-test
    - echo "clean container"

dockerhub-release:
  stage: Release
  script: 
    - docker load < ic-webapp.tar
    - docker tag ic-webapp:1.0 "${DOCKERHUB_USERNAME}/${REPO_NAME}:${IMAGE_TAG}" #${CI_COMMIT_REF_NAME}"
    - docker tag ic-webapp:1.0 "${DOCKERHUB_USERNAME}/${REPO_NAME}:${CI_COMMIT_SHORT_SHA}"
    - echo "$DOCKERHUB_PASSWORD" | docker login -u "$DOCKERHUB_USERNAME" --password-stdin
    - docker push "${DOCKERHUB_USERNAME}/${REPO_NAME}:${IMAGE_TAG}" #${CI_COMMIT_REF_NAME}"
    - docker push "${DOCKERHUB_USERNAME}/${REPO_NAME}:${CI_COMMIT_SHORT_SHA}"

gitlab-release:
  stage: Release
  script:
    - docker load < ic-webapp.tar
    - docker tag ic-webapp:1.0 "${CI_REGISTRY_IMAGE}:${IMAGE_TAG}"
    - docker tag ic-webapp:1.0 "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}"
    - echo "$CI_REGISTRY_PASSWORD" | docker login -u "$CI_REGISTRY_USER" --password-stdin $CI_REGISTRY
    - docker push "${CI_REGISTRY_IMAGE}:${IMAGE_TAG}"
    - docker push "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}"

deploy-test: #
  image: alpine:latest
  stage: Deploy test
  script:
    - docker stop test-${REPO_NAME} && docker rm -vf test-${REPO_NAME} || true
    - chmod 600 $ID_RSA
    - apk update && apk add openssh-client
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "echo $DOCKERHUB_PASSWORD | docker login -u $DOCKERHUB_USERNAME --password-stdin"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "sudo docker pull ${DOCKERHUB_USERNAME}/${REPO_NAME}:${IMAGE_TAG}" #${CI_COMMIT_REF_NAME}"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "sudo docker container rm -f test-${REPO_NAME} || true"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "sudo docker run --rm -d -p 8080:8080 --name test-${REPO_NAME} ${DOCKERHUB_USERNAME}/${REPO_NAME}:${IMAGE_TAG}" #${CI_COMMIT_REF_NAME}"
  environment:
    name: test
    url: http://$SERVER_IP:8080
  only:
    - main

test-test:
  <<: *test
  stage: Test test
  variables:
    DOMAIN: $SERVER_IP:8080

stop-test:
  stage: Stop test
  variables:
    GIT_STRATEGY: none
  when: manual
  environment:
    name: test/$CI_COMMIT_REF_NAME
    action: stop
  script:
    - chmod 600 $ID_RSA
    - apk update && apk add openssh-client
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker container rm -f ${DOCKERHUB_USERNAME}${REPO_NAME} || true"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker stop test-${REPO_NAME} && docker rm -vf test-${REPO_NAME}"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker rmi ${DOCKERHUB_USERNAME}/${REPO_NAME}:${IMAGE_TAG}"